--#=================================================================
--# LWS Main Script - Import all modules and config file
--# Created by Shaolan - http://shaolanweb.olympe-network.com
--#==================================================================

wl = {running = true,this = {},io = {}}
wl.io.padPress = function()
			      if wl.io.pad:cross() or wl.io.pad:circle() or wl.io.pad:square() or wl.io.pad:triangle() or wl.io.pad:r() or wl.io.pad:l() or wl.io.pad:up() or wl.io.pad:down() or wl.io.pad:left() or wl.io.pad:right()  or wl.io.pad:start() or wl.io.pad:select() then
				   return true
				  else 
				    if wl.io.pad:analogX() > 90 or wl.io.pad:analogY() > 90 or wl.io.pad:analogX() < 0-90 or wl.io.pad:analogY() < 0-90  then
					 return true
					else
					 return false
					end
				  end 
				 end  
dofile("config")
dofile(WL_PATH.."event.lua")
dofile(WL_PATH.."io.lua")
dofile(WL_PATH.."object.lua")

function eventType()
 return {
		 onMouseOver = function() end,
		 onMouseOut = function() end,
		 onClick = function() end,
		 onMove = function() end,
		 onNothing = function() end
		}
end

--#=================
--# Object definition :
function wl.NewDesktop(style,path)
 local pic = Image.createEmpty(480,272)
 pic:clear(WL_DESKTOP_COLOR)
 if style == true then pic:blit(0,0,Image.load(path)) end
 local this,self = {},{}
 local connect = function(obj)
				  table.insert(this,obj)
				 end
 return {this=this,self=self,connect = connect,pic=pic}
end


function wl.startMainLoop(desktop)
 wl.io.mouse = Mouse.new()
 checkEvent = function(obj)
					 if onMouseOver(obj.self.x,obj.self.x+obj.self.w,obj.self.y,obj.self.y+obj.self.h) then 
					  obj.event.onMouseOver()
					  obj.self.mouseOver = true
					  if wl.io.pad:cross() then obj.event.onClick() end
					  if wl.io.pad:up() or wl.io.pad:down() or wl.io.pad:left() or wl.io.pad:right() then
					    obj.event.onMove()
					  end
					 elseif obj.self.mouseOver == true then 
					  obj.event.onMouseOut() 
					  obj.self.mouseOver = false
					 end
					 obj.event.onNothing()
					end
 upTree = function(obj)
			     if obj.this ~= nil and #obj.this ~= 0 then 
				  for i=1,#obj.this do
				   checkEvent(obj.this[i])
				   upTree(obj.this[i])
				  end
				 end 
				end
 upTreeBlit = function(obj)
			     if obj.this ~= nil and #obj.this ~= 0 then 
				  for i=1,#obj.this do
				   screen:blit(obj.this[i].self.x,obj.this[i].self.y,obj.this[i].pic)
				   upTreeBlit(obj.this[i])
				  end
				 end 
				end				
 local reload = function()
					screen:clear()
					screen:blit(0,0,desktop.pic)
					upTreeBlit(desktop)
					wl.io.mouse.play()
					screen.flip()
					screen.waitVblankStart()
				end
  reload()
  s=0
 while wl.running do
  wl.io.pad = Controls.read()
  wl.io.mouse.update()
  if wl.io.pad:triangle() then screen:save("screen"..s..".png") s=s+1 end
  upTree(desktop)
  if wl.io.padPress() then
   reload()
  end
 end
end