--##==============================================================
--##----------------------------------------------------------------------------------------- #
--## DAPESi :Drawing And Picture Editing Software Improved ===========
--##----------------------------------------------------------------------------------------- ==
--##----------------------------------------------------------------------------------------- ==
--## Authors : Shaolan , Elesthor 									#
--##  This application use my new Widget Library under GNU GPL licence #
--##==============================================================
System.setHigh()

screen:blit(0,0,Image.load("Data/splash.png"))
screen.flip()
screen.waitVblankStart()
a = 10000
while a > 0 do
 a = a -1
 end
 
dofile("System/WL/main.lua")
dofile("System/Modules/main.lua")

param = {primaryCO = Color.new(0,0,0),secondaryCO = Color.new(255,255,255),tools = "Pen"}
file = {path="",w=200,h=200,scrollX=0,scrollY=0,zoom=1}
task = {running = false,colorPanel = false,line={running=false,xs=0,ys=0},select={running=false,xs=0,ys=0}}
--#===========================================
--# Interface part, using WL library 
--#===========================================

Desktop = wl.NewDesktop(CUSTOM,"Data/bg.png")
--# Option Box definition
option = wl.NewPanel({w=100,h=272,x=0,y=0,border={0,0,1,0}})
	--#Option panel by tools :
	 --#Color Panel :
     ColorPanel= wl.NewPanel({w=90,h=222,x=5,y=60,bgcolor=Color.new(0,0,0,0),border={0,1,0,0}})
		paletteButton = wl.NewButton({w=90,h=90,x=0,y=10,path="Data/palette.png"})
		paletteButton.event.onClick = function()
										param.primaryCO = paletteButton.pic:pixel(wl.io.mouse.self.x-paletteButton.self.x,wl.io.mouse.self.y-paletteButton.self.y)
										Primary.self.color = param.primaryCO 
										Primary.reload()
									end	
	    new = wl.NewButton({w=80,h=15,x=5,y=120,path="Data/new.png"})
	    open = wl.NewButton({w=80,h=15,x=5,y=140,path="Data/open.png"})
	    save = wl.NewButton({w=80,h=15,x=5,y=160,path="Data/save.png"})
		
		new.event.onClick = function()
		                      drawArea.reset()
							  drawArea.reload()
							end
		
		ColorPanel.connect(paletteButton)							
		ColorPanel.connect(new)							
		ColorPanel.connect(open)							
		ColorPanel.connect(save)							
	option.connect(ColorPanel)	
    Primary = wl.NewColorArea({w=20,h=20,x=30,y=15,color=param.primaryCO})
	Primary.event.onClick = function ()
	                         task.colorPanel = true
							 option.update(1,ColorPanel)
							end
    Secondary = wl.NewColorArea({w=20,h=20,x=40,y=25,color=param.secondaryCO})
    option.connect(Secondary)
    option.connect(Primary)
	--#  Palette definiton 
	
--# This is the core of the application : all image 's manipulation is here :	
drawArea = wl.NewDrawArea({x=110,y=25,w=360,h=240,
						   ah=100,aw=100,
						   border={1,1,1,1},bordercolor=Color.new(0,0,0),
						   bgcolor=Color.new(255,255,255),abgcolor=Color.new(255,255,255),
						   bgimg="Data/areaBG.png"})	
drawArea.event.onClick = function()
                          if wl.io.mouse.self.x-110 < drawArea.self.aw and wl.io.mouse.self.y-25 < drawArea.self.ah and not(onMouseOver(Desktop.this[2].self.x,Desktop.this[2].self.x + Desktop.this[2].self.w,Desktop.this[2].self.y,Desktop.this[2].self.y + Desktop.this[2].self.h)) then
						   tempPic = drawArea.getArea()
							if param.tools == "Pen" then
								tempPic:fillRect((wl.io.mouse.self.x - drawArea.self.x + 1 + file.scrollX)-((wl.io.mouse.self.x - drawArea.self.x + 1+ file.scrollX)%file.zoom),(wl.io.mouse.self.y - drawArea.self.y + 1+ file.scrollY)-((wl.io.mouse.self.y - drawArea.self.y + 1 + file.scrollY)%file.zoom),file.zoom,file.zoom,param.primaryCO)
							elseif param.tools == "Fill" then
								tempPic = gfx.fill(tempPic,(wl.io.mouse.self.x - drawArea.self.x + 1 + file.scrollX)-((wl.io.mouse.self.x - drawArea.self.x + 1 + file.scrollX)%file.zoom),(wl.io.mouse.self.y - drawArea.self.y + 1 + file.scrollY)-((wl.io.mouse.self.y - drawArea.self.y + 1 + file.scrollY)%file.zoom))						  
						    elseif param.tools == "Selection" then
							    
						    elseif param.tools == "Texte" then
						    elseif param.tools == "Zoom" then
							    System.sleep(50)
								if wl.io.pad:r() then
								 tempPic,success = gfx.zoomOut(tempPic)
								 if success then drawArea.self.aw,drawArea.self.ah = drawArea.self.aw/2,drawArea.self.ah/2 end
								else
								 tempPic,success = gfx.zoomIn(tempPic)
								 if success then drawArea.self.aw,drawArea.self.ah = drawArea.self.aw*2,drawArea.self.ah*2 end
								end
						    elseif param.tools == "Ligne" then
							    if task.line.running then
								 task.line.running = false
								 tempPic = gfx.line(tempPic,task.line.xs,task.line.ys,(wl.io.mouse.self.x - drawArea.self.x + 1)-((wl.io.mouse.self.x - drawArea.self.x + 1)%file.zoom),(wl.io.mouse.self.y - drawArea.self.y + 1)-((wl.io.mouse.self.y - drawArea.self.y + 1)%file.zoom))
								else
								 task.line.running = true
								 task.line.xs = (wl.io.mouse.self.x - drawArea.self.x + 1)-((wl.io.mouse.self.x - drawArea.self.x + 1)%file.zoom)
								 task.line.ys = (wl.io.mouse.self.y - drawArea.self.y + 1)-((wl.io.mouse.self.y - drawArea.self.y + 1)%file.zoom)
								 tempPic = gfx.line(tempPic,task.line.xs,task.line.ys,(wl.io.mouse.self.x - drawArea.self.x + 1)-((wl.io.mouse.self.x - drawArea.self.x + 1)%file.zoom),(wl.io.mouse.self.y - drawArea.self.y + 1)-((wl.io.mouse.self.y - drawArea.self.y + 1)%file.zoom))
								end
						    elseif param.tools == "Fiole" then
								param.primaryCO = drawArea.getArea():pixel(wl.io.mouse.self.x - drawArea.self.x + file.scrollX + 1,wl.io.mouse.self.y - drawArea.self.y + file.scrollY +1)
								Primary.self.color = param.primaryCO 
								Primary.reload()
							end
						  drawArea.setArea(tempPic)
						  drawArea.reload()
						  end	
						 end

drawArea.event.onMove = function()
						end  
						
Desktop.connect(drawArea)
--# Tools Box definiton (which contain a textField for icon description and button object)
tools = wl.NewPanel({w=294,h=50,x=150,y=222,border={1,1,1,0}})
toolsList = {"Pen","Fill","None","None","Zoom","None","Fiole"}
toolsButton = {}
toolsTextField = wl.NewTextField({x=10,y=5,h=10,w=150,value=param.tools})
tools.connect(toolsTextField)

for i=1,7 do
 toolsButton[i] = wl.NewButton({w=32,h=32,x=10+((i-1)*40),y=15,path="Data/icon/"..i..".png"})
 toolsButton[i].event.onClick = function() param.tools = toolsList[i] end
 toolsButton[i].event.onMouseOver = function() toolsButton[i].parent.this[1].setValue(toolsList[i]) end
 toolsButton[i].event.onMouseOut = function() toolsButton[i].parent.this[1].setValue(param.tools) end
 tools.connect(toolsButton[i])
end

Desktop.connect(tools)
Desktop.connect(option)
wl.startMainLoop(Desktop)